Subject: [PATCH v8 3/6] Uprobes: Support SDT markers having reference count (semaphore)

From: [email-masked] (Oleg Nesterov)
Date: Mon, 13 Aug 2018 15:17:24 +0200

On 08/13, Ravi Bangoria wrote:
>
> > But damn, process creation (exec) is trivial. We could add a new uprobe_exec()
> > hook and avoid delayed_uprobe_install() in uprobe_mmap().
>
> I'm sorry. I didn't get this.

Sorry for confusion...

I meant, if only exec*( could race with _register(), we could add another uprobe
hook which updates all (delayed) counters before return to user-mode.

> > Afaics, the really problematic case is dlopen() which can race with _register()
> > too, right?
>
> dlopen() should internally use mmap() right? So what is the problem here? Can
> you please elaborate.

What I tried to say is that we can't avoid uprobe_mmap()->delayed_uprobe_install()
because dlopen() can race with _register() too, just like exec.

Oleg.